Debian Bug report logs - #475101
Remove obsolete -D_REENTRANT requirement

version graph

Package: debian-policy; Maintainer for debian-policy is Debian Policy List <debian-policy@lists.debian.org>; Source for debian-policy is src:debian-policy.

Reported by: Joey Hess <joeyh@debian.org>

Date: Wed, 9 Apr 2008 00:24:01 UTC

Severity: wishlist

Found in version debian-policy/3.7.3.0

Fixed in version debian-policy/3.9.1.0

Done: Russ Allbery <rra@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: obsolete linuxthreads requirement
Date: Tue, 8 Apr 2008 20:22:10 -0400
[Message part 1 (text/plain, inline)]
Package: debian-policy
Version: 3.7.3.0
Severity: normal

     You must specify the gcc option `-D_REENTRANT' when building a library
     (either static or shared) to make the library compatible with
     LinuxThreads.

AFAIK we don't use linuxthreads anymore, and I checked a few libraries and
failed to find them using such a flag.

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable'), (1, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 2.6.24-1-686 (SMP w/1 CPU core)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

-- no debconf information

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 475101@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Joey Hess <joeyh@debian.org>, 475101@bugs.debian.org
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Thu, 10 Apr 2008 08:32:44 +0200
On Tue, Apr 08, 2008 at 08:22:10PM -0400, Joey Hess wrote:
> Package: debian-policy
> Version: 3.7.3.0
> Severity: normal
> 
>      You must specify the gcc option `-D_REENTRANT' when building a library
>      (either static or shared) to make the library compatible with
>      LinuxThreads.
> 
> AFAIK we don't use linuxthreads anymore, and I checked a few libraries and
> failed to find them using such a flag.

I think hppa still uses it.

The -D_REENTRANT might also be used in other libraries that can be
compiled to support threads or not.  But those might also be using some
other options.  I think we should just say that all libraries should
get build with thread support if they support it.


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Simon Josefsson <simon@josefsson.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 475101@bugs.debian.org (full text, mbox):

From: Simon Josefsson <simon@josefsson.org>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: 475101@bugs.debian.org, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Thu, 10 Apr 2008 09:28:03 +0200
Kurt Roeckx <kurt@roeckx.be> writes:

> On Tue, Apr 08, 2008 at 08:22:10PM -0400, Joey Hess wrote:
>> Package: debian-policy
>> Version: 3.7.3.0
>> Severity: normal
>> 
>>      You must specify the gcc option `-D_REENTRANT' when building a library
>>      (either static or shared) to make the library compatible with
>>      LinuxThreads.
>> 
>> AFAIK we don't use linuxthreads anymore, and I checked a few libraries and
>> failed to find them using such a flag.
>
> I think hppa still uses it.
>
> The -D_REENTRANT might also be used in other libraries that can be
> compiled to support threads or not.  But those might also be using some
> other options.  I think we should just say that all libraries should
> get build with thread support if they support it.

Do you have any references to the hppa case (in particular, does it
affect glibc/debian on hppa?), and which these libraries are?

I have tried to find modern references to what -D_REENTRANT actually
does, but haven't found any concrete examples of what breaks if you
don't use it.  I have now disabled it in gnutls.  Some potentially
relevant discussions in:

http://thread.gmane.org/gmane.comp.encryption.gpg.gnutls.devel/2495
http://thread.gmane.org/gmane.comp.lib.gnulib.bugs/12892
http://thread.gmane.org/gmane.comp.lib.gnulib.bugs/12876

/Simon




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 475101@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Simon Josefsson <simon@josefsson.org>
Cc: 475101@bugs.debian.org, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Thu, 10 Apr 2008 23:21:01 +0200
On Thu, Apr 10, 2008 at 09:28:03AM +0200, Simon Josefsson wrote:
> Kurt Roeckx <kurt@roeckx.be> writes:
> 
> > On Tue, Apr 08, 2008 at 08:22:10PM -0400, Joey Hess wrote:
> >> Package: debian-policy
> >> Version: 3.7.3.0
> >> Severity: normal
> >> 
> >>      You must specify the gcc option `-D_REENTRANT' when building a library
> >>      (either static or shared) to make the library compatible with
> >>      LinuxThreads.
> >> 
> >> AFAIK we don't use linuxthreads anymore, and I checked a few libraries and
> >> failed to find them using such a flag.
> >
> > I think hppa still uses it.
> >
> > The -D_REENTRANT might also be used in other libraries that can be
> > compiled to support threads or not.  But those might also be using some
> > other options.  I think we should just say that all libraries should
> > get build with thread support if they support it.
> 
> Do you have any references to the hppa case (in particular, does it
> affect glibc/debian on hppa?), and which these libraries are?

http://lists.debian.org/debian-release/2008/03/msg00367.html

says:
> - All Linux platforms except hppa have switched to NPTL. 2.4 kernels
>   are not supported anymore.


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Simon Josefsson <simon@josefsson.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 475101@bugs.debian.org (full text, mbox):

From: Simon Josefsson <simon@josefsson.org>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: 475101@bugs.debian.org, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Fri, 11 Apr 2008 08:23:19 +0200
Kurt Roeckx <kurt@roeckx.be> writes:

> On Thu, Apr 10, 2008 at 09:28:03AM +0200, Simon Josefsson wrote:
>> Kurt Roeckx <kurt@roeckx.be> writes:
>> 
>> > On Tue, Apr 08, 2008 at 08:22:10PM -0400, Joey Hess wrote:
>> >> Package: debian-policy
>> >> Version: 3.7.3.0
>> >> Severity: normal
>> >> 
>> >>      You must specify the gcc option `-D_REENTRANT' when building a library
>> >>      (either static or shared) to make the library compatible with
>> >>      LinuxThreads.
>> >> 
>> >> AFAIK we don't use linuxthreads anymore, and I checked a few libraries and
>> >> failed to find them using such a flag.
>> >
>> > I think hppa still uses it.
>> >
>> > The -D_REENTRANT might also be used in other libraries that can be
>> > compiled to support threads or not.  But those might also be using some
>> > other options.  I think we should just say that all libraries should
>> > get build with thread support if they support it.
>> 
>> Do you have any references to the hppa case (in particular, does it
>> affect glibc/debian on hppa?), and which these libraries are?
>
> http://lists.debian.org/debian-release/2008/03/msg00367.html
>
> says:
>> - All Linux platforms except hppa have switched to NPTL. 2.4 kernels
>>   are not supported anymore.

Thanks.  But does LinuxThreads need -D_REENTRANT today?  The links to
the gnulib list I gave suggested that it isn't necessary, but without
knowing exactly what to test it is difficult to know for sure.

I don't know much about thread stuff, but my hope is that we could
derive some concrete explanation of what breaks if you don't add
-D_REENTRANT when building debian packages.  That would make it possible
to come back to this text later and evaluate whether the reasons for
having the text are still valid.

/Simon




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 475101@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Simon Josefsson <simon@josefsson.org>, 475101@bugs.debian.org
Cc: Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Sat, 12 Apr 2008 18:27:44 +0200
On Fri, Apr 11, 2008 at 08:23:19AM +0200, Simon Josefsson wrote:
> 
> Thanks.  But does LinuxThreads need -D_REENTRANT today?  The links to
> the gnulib list I gave suggested that it isn't necessary, but without
> knowing exactly what to test it is difficult to know for sure.

I think that testing that errno is thread local instead of global is a
good test to see if it's needed.

I know that "extern int errno;" used to work on systems using
LinuxThreads, but that it fails to link on systems using NPTL.
But even the errno.h from i386 sarge seems to use (*__errno_location ()).

So it looks to me that _REENTRANT is only used to make some functions
like getlogin_r available.

> I don't know much about thread stuff, but my hope is that we could
> derive some concrete explanation of what breaks if you don't add
> -D_REENTRANT when building debian packages.  That would make it possible
> to come back to this text later and evaluate whether the reasons for
> having the text are still valid.

I think that on a Debian system using glibc using _REENTRANT isn't
needed if:
- You don't need specialy reentrant functions from libc;
- Other libraries you're using have something in their include
  files that change behaviour depending on _REENTRANT;
- The package you're building itself doesn't change change behaviour
  depending on _REENTRANT.

I think that libraries in Debian should never change behaviour based on
_REENTRANT.  If a library can be build to either support threads or
not, it should be compiled to support threads.  It might also want to
provide one that does and one that doesn't so that you can link to
either one, but I would like to discourage that, and the default library
should be the one that supports threads.  And if it does provide 2
libraries, the header files for both should be the same and not depend
on _REENTRANT.


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Simon Josefsson <simon@josefsson.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 475101@bugs.debian.org (full text, mbox):

From: Simon Josefsson <simon@josefsson.org>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: 475101@bugs.debian.org, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Sat, 12 Apr 2008 21:15:21 +0200
Kurt Roeckx <kurt@roeckx.be> writes:

> On Fri, Apr 11, 2008 at 08:23:19AM +0200, Simon Josefsson wrote:
>> 
>> Thanks.  But does LinuxThreads need -D_REENTRANT today?  The links to
>> the gnulib list I gave suggested that it isn't necessary, but without
>> knowing exactly what to test it is difficult to know for sure.
>
> I think that testing that errno is thread local instead of global is a
> good test to see if it's needed.

Agreed.

> I know that "extern int errno;" used to work on systems using
> LinuxThreads, but that it fails to link on systems using NPTL.

I believe one needs to use '#include <errno.h>' to be portable nowadays,
at least according to:

http://www.opengroup.org/onlinepubs/009695399/functions/errno.html

> But even the errno.h from i386 sarge seems to use (*__errno_location ()).

Right.

> So it looks to me that _REENTRANT is only used to make some functions
> like getlogin_r available.

That is how I understand the situation as well.

>> I don't know much about thread stuff, but my hope is that we could
>> derive some concrete explanation of what breaks if you don't add
>> -D_REENTRANT when building debian packages.  That would make it possible
>> to come back to this text later and evaluate whether the reasons for
>> having the text are still valid.
>
> I think that on a Debian system using glibc using _REENTRANT isn't
> needed if:
> - You don't need specialy reentrant functions from libc;

To be more precise: if you don't need the *.h prototype's for the
specialy reentrant functions.

> - Other libraries you're using have something in their include
>   files that change behaviour depending on _REENTRANT;

Right.

libxml2 may be one such candidate, at least it inspects _REENTRANT in
/usr/include/libxml2/libxml/xmlversion.h.  I'm not sure if its value
matters though.

> - The package you're building itself doesn't change change behaviour
>   depending on _REENTRANT.

Right.

> I think that libraries in Debian should never change behaviour based on
> _REENTRANT.  If a library can be build to either support threads or
> not, it should be compiled to support threads.  It might also want to
> provide one that does and one that doesn't so that you can link to
> either one, but I would like to discourage that, and the default library
> should be the one that supports threads.  And if it does provide 2
> libraries, the header files for both should be the same and not depend
> on _REENTRANT.

I think I agree here too, although I'm not as confident.

In any case, I think we can safely assert that many libraries don't need
-D_REENTRANT.

The trade-off then is to compare the costs of forcing maintainers (via
the policy) to build all libraries in Debian with a special flag against
the costs of potentially running into some library that actually need
the flag in order to not cause problems in a threaded environment.

My general preference is to only do exceptions when they are known to be
needed, and avoid bloating all software for the benefit of a few
scenarios.  Thus, I would prefer if in the (likely few) cases where
setting -D_REENTRANT is required, that it is done explicitly only in
those cases.

I wouldn't want to change something like this at this time in the
release cycle though.

This discussion reinforced the rationale for my decision that GnuTLS
should not set -D_REENTRANT when it is built.  It doesn't use any
reentrant functions, and its use of errno is thread safe since it
accesses it via errno.h.  There may be non-debian systems were it is
needed, but I'd prefer to add it only on those platforms.

/Simon




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Mark Brown <broonie@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #40 received at 475101@bugs.debian.org (full text, mbox):

From: Mark Brown <broonie@debian.org>
To: Kurt Roeckx <kurt@roeckx.be>, 475101@bugs.debian.org
Cc: Simon Josefsson <simon@josefsson.org>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Sun, 13 Apr 2008 19:43:04 +0100
On Sat, Apr 12, 2008 at 06:27:44PM +0200, Kurt Roeckx wrote:

> _REENTRANT.  If a library can be build to either support threads or
> not, it should be compiled to support threads.  It might also want to

That's what I'd always understood the intent of this requirement to be -
it was that way because core things like libc needed that flag to be
thread safe.

-- 
"You grabbed my hand and we fell into it, like a daydream - or a fever."




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #45 received at 475101@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Kurt Roeckx <kurt@roeckx.be>, 475101@bugs.debian.org
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Wed, 16 Apr 2008 22:47:29 -0700
On Thu, Apr 10, 2008 at 08:32:44AM +0200, Kurt Roeckx wrote:
> On Tue, Apr 08, 2008 at 08:22:10PM -0400, Joey Hess wrote:
> > Package: debian-policy
> > Version: 3.7.3.0
> > Severity: normal

> >      You must specify the gcc option `-D_REENTRANT' when building a library
> >      (either static or shared) to make the library compatible with
> >      LinuxThreads.

> > AFAIK we don't use linuxthreads anymore, and I checked a few libraries and
> > failed to find them using such a flag.

> I think hppa still uses it.

> The -D_REENTRANT might also be used in other libraries that can be
> compiled to support threads or not.  But those might also be using some
> other options.  I think we should just say that all libraries should
> get build with thread support if they support it.

That would seem to imply that it's ok for libraries to not be thread-safe...

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
Ubuntu Developer                                    http://www.debian.org/
slangasek@ubuntu.com                                     vorlon@debian.org




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. Full text and rfc822 format available.

Message #50 received at 475101@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: Kurt Roeckx <kurt@roeckx.be>
Cc: 475101@bugs.debian.org, Simon Josefsson <simon@josefsson.org>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Mon, 21 Apr 2008 15:54:20 -0700
Kurt Roeckx <kurt@roeckx.be> writes:

> So it looks to me that _REENTRANT is only used to make some functions
> like getlogin_r available.

I believe that's correct, and the discussion at the last DebConf reached
the same conclusion.  I think this bit in Policy is obsolete.  I already
closed a Lintian bug about it a while back.

You may separately need _REENTRANT to get prototypes, but using the right
feature test macros to get prototypes is a completely different issue and
I don't think we need to leave this in Policy just for that (otherwise,
we'd need to talk about GNU_SOURCE and whatnot as well, and I don't see a
need to go there right now).

> I think that libraries in Debian should never change behaviour based on
> _REENTRANT.  If a library can be build to either support threads or not,
> it should be compiled to support threads.  It might also want to provide
> one that does and one that doesn't so that you can link to either one,
> but I would like to discourage that, and the default library should be
> the one that supports threads.  And if it does provide 2 libraries, the
> header files for both should be the same and not depend on _REENTRANT.

I think I agree.  Could someone propose a wording change to Policy to say
what we really mean here rather than focusing on _REENTRANT?

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Severity set to `wishlist' from `normal' Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Sun, 27 Apr 2008 23:00:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Sat, 03 Jul 2010 19:27:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sat, 03 Jul 2010 19:27:10 GMT) Full text and rfc822 format available.

Message #57 received at 475101@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 475101@bugs.debian.org
Cc: Kurt Roeckx <kurt@roeckx.be>, Simon Josefsson <simon@josefsson.org>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Sat, 03 Jul 2010 12:26:40 -0700
Russ Allbery <rra@debian.org> writes:
> Kurt Roeckx <kurt@roeckx.be> writes:

>> So it looks to me that _REENTRANT is only used to make some functions
>> like getlogin_r available.

> I believe that's correct, and the discussion at the last DebConf reached
> the same conclusion.  I think this bit in Policy is obsolete.  I already
> closed a Lintian bug about it a while back.

> You may separately need _REENTRANT to get prototypes, but using the right
> feature test macros to get prototypes is a completely different issue and
> I don't think we need to leave this in Policy just for that (otherwise,
> we'd need to talk about GNU_SOURCE and whatnot as well, and I don't see a
> need to go there right now).

>> I think that libraries in Debian should never change behaviour based on
>> _REENTRANT.  If a library can be build to either support threads or not,
>> it should be compiled to support threads.  It might also want to provide
>> one that does and one that doesn't so that you can link to either one,
>> but I would like to discourage that, and the default library should be
>> the one that supports threads.  And if it does provide 2 libraries, the
>> header files for both should be the same and not depend on _REENTRANT.

> I think I agree.  Could someone propose a wording change to Policy to say
> what we really mean here rather than focusing on _REENTRANT?

Here's an attempt at that.  I'm not sure if this says everything that
needs to be said, but I'm not sure what else to say.

I considered saying, as Kurt does above, that two libraries could be
provided, one with thread support and one without, but this poses some
serious problems because both libraries could be loaded into the same
process space and then conflict.  Doing this properly requires symbol
versioning or some other similar mechanism, and at that point I think
we're getting into something that's too difficult and specific to describe
in Policy.  I think I'd rather just let the "should" rather than "must"
provide wiggle-room for that.

Objections or seconds?

diff --git a/policy.sgml b/policy.sgml
index bad28af..1ffe148 100644
--- a/policy.sgml
+++ b/policy.sgml
@@ -7225,10 +7225,10 @@ INSTALL = install -s # (or use strip on the files in debian/tmp)
           for C files) will need to be compiled twice, for the normal
           case. 
         </p>
+
 	<p>
-	  You must specify the gcc option <tt>-D_REENTRANT</tt>
-	  when building a library (either static or shared) to make
-	  the library compatible with LinuxThreads.
+	  Libraries should be built with threading support and to be
+	  thread-safe if the library supports this.
 	</p>
 
         <p>

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Added tag(s) patch. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Sat, 03 Jul 2010 19:30:02 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Sun, 04 Jul 2010 08:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Josefsson <simon@josefsson.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 04 Jul 2010 08:33:03 GMT) Full text and rfc822 format available.

Message #64 received at 475101@bugs.debian.org (full text, mbox):

From: Simon Josefsson <simon@josefsson.org>
To: Russ Allbery <rra@debian.org>
Cc: 475101@bugs.debian.org, Kurt Roeckx <kurt@roeckx.be>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Sun, 04 Jul 2010 10:15:49 +0200
Russ Allbery <rra@debian.org> writes:

> Russ Allbery <rra@debian.org> writes:
>> Kurt Roeckx <kurt@roeckx.be> writes:
>
>>> So it looks to me that _REENTRANT is only used to make some functions
>>> like getlogin_r available.
>
>> I believe that's correct, and the discussion at the last DebConf reached
>> the same conclusion.  I think this bit in Policy is obsolete.  I already
>> closed a Lintian bug about it a while back.
>
>> You may separately need _REENTRANT to get prototypes, but using the right
>> feature test macros to get prototypes is a completely different issue and
>> I don't think we need to leave this in Policy just for that (otherwise,
>> we'd need to talk about GNU_SOURCE and whatnot as well, and I don't see a
>> need to go there right now).
>
>>> I think that libraries in Debian should never change behaviour based on
>>> _REENTRANT.  If a library can be build to either support threads or not,
>>> it should be compiled to support threads.  It might also want to provide
>>> one that does and one that doesn't so that you can link to either one,
>>> but I would like to discourage that, and the default library should be
>>> the one that supports threads.  And if it does provide 2 libraries, the
>>> header files for both should be the same and not depend on _REENTRANT.
>
>> I think I agree.  Could someone propose a wording change to Policy to say
>> what we really mean here rather than focusing on _REENTRANT?
>
> Here's an attempt at that.  I'm not sure if this says everything that
> needs to be said, but I'm not sure what else to say.
>
> I considered saying, as Kurt does above, that two libraries could be
> provided, one with thread support and one without, but this poses some
> serious problems because both libraries could be loaded into the same
> process space and then conflict.  Doing this properly requires symbol
> versioning or some other similar mechanism, and at that point I think
> we're getting into something that's too difficult and specific to describe
> in Policy.  I think I'd rather just let the "should" rather than "must"
> provide wiggle-room for that.
>
> Objections or seconds?

I don't think it should reference _REENTRANT any more for modern
GNU/Linux system like Debian.

LinuxThreads is an old thread implementation -- see
http://pauillac.inria.fr/~xleroy/linuxthreads/ -- that is not used any
more.  It is not even packaged in Debian.

The only need for _REENTRANT I know is OSF/1:

        # On OSF/1, the compiler needs the flag -D_REENTRANT so that it
        # groks <pthread.h>. cc also understands the flag -pthread, but
        # we don't use it because 1. gcc-2.95 doesn't understand -pthread,
        # 2. putting a flag into CPPFLAGS that has an effect on the linker
        # causes the AC_TRY_LINK test below to succeed unexpectedly,
        # leading to wrong values of LIBTHREAD and LTLIBTHREAD.
        CPPFLAGS="$CPPFLAGS -D_REENTRANT"

and Solaris:

    # Some systems optimize for single-threaded programs by default, and
    # need special flags to disable these optimizations. For example, the
    # definition of 'errno' in <errno.h>.
    case "$host_os" in
...
      solaris*) CPPFLAGS="$CPPFLAGS -D_REENTRANT" ;;

GNU/Linux doesn't need it as far as I have been able to determine.

getlogin_r appears to be declared by default now, /usr/include/unistd.h
says:

#if defined __USE_REENTRANT || defined __USE_POSIX199506
...
extern int getlogin_r (char *__name, size_t __name_len) __nonnull ((1));

But __USE_POSIX199506 is defined by default.

Lacking any real evidence of the need of _REENTRANT, I have long since
removed all uses of _REENTRANT in my projects (and gnulib) and these
projects are used in multi-threaded environments without problem.  On
the other hand, I know that some Debian packages re-add _REENTRANT.

Thus, I would suggest simply saying this:

	<p>
	  Libraries should be built with threading support and to be
	  thread-safe if the library supports this.
	</p>

Alternatively, provide the _real_ rationale for _REENTRANT.  I'm pretty
sure LinuxThreads isn't a valid rationale for it these days -- or am I
wrong?

/Simon

> diff --git a/policy.sgml b/policy.sgml
> index bad28af..1ffe148 100644
> --- a/policy.sgml
> +++ b/policy.sgml
> @@ -7225,10 +7225,10 @@ INSTALL = install -s # (or use strip on the files in debian/tmp)
>            for C files) will need to be compiled twice, for the normal
>            case. 
>          </p>
> +
>  	<p>
> -	  You must specify the gcc option <tt>-D_REENTRANT</tt>
> -	  when building a library (either static or shared) to make
> -	  the library compatible with LinuxThreads.
> +	  Libraries should be built with threading support and to be
> +	  thread-safe if the library supports this.
>  	</p>
>  
>          <p>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Sun, 04 Jul 2010 08:45:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 04 Jul 2010 08:45:02 GMT) Full text and rfc822 format available.

Message #69 received at 475101@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Russ Allbery <rra@debian.org>
Cc: 475101@bugs.debian.org, Simon Josefsson <simon@josefsson.org>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Sun, 4 Jul 2010 10:42:25 +0200
On Sat, Jul 03, 2010 at 12:26:40PM -0700, Russ Allbery wrote:
> --- a/policy.sgml
> +++ b/policy.sgml
> @@ -7225,10 +7225,10 @@ INSTALL = install -s # (or use strip on the files in debian/tmp)
>            for C files) will need to be compiled twice, for the normal
>            case. 
>          </p>
> +
>  	<p>
> -	  You must specify the gcc option <tt>-D_REENTRANT</tt>
> -	  when building a library (either static or shared) to make
> -	  the library compatible with LinuxThreads.
> +	  Libraries should be built with threading support and to be
> +	  thread-safe if the library supports this.
>  	</p>
>  
>          <p>

Seconded.


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Sun, 04 Jul 2010 16:03:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Sun, 04 Jul 2010 16:03:09 GMT) Full text and rfc822 format available.

Message #74 received at 475101@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: Simon Josefsson <simon@josefsson.org>
Cc: 475101@bugs.debian.org, Kurt Roeckx <kurt@roeckx.be>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Sun, 04 Jul 2010 09:00:44 -0700
Simon Josefsson <simon@josefsson.org> writes:

> I don't think it should reference _REENTRANT any more for modern
> GNU/Linux system like Debian.

I think I may not have provided enough context, but indeed, that's the
point of this bug and my proposed patch.

> Thus, I would suggest simply saying this:

> 	<p>
> 	  Libraries should be built with threading support and to be
> 	  thread-safe if the library supports this.
> 	</p>

Yes, that's what I'm proposing -- at a guess, you may have misread the
diff?

>> diff --git a/policy.sgml b/policy.sgml
>> index bad28af..1ffe148 100644
>> --- a/policy.sgml
>> +++ b/policy.sgml
>> @@ -7225,10 +7225,10 @@ INSTALL = install -s # (or use strip on the files in debian/tmp)
>>            for C files) will need to be compiled twice, for the normal
>>            case. 
>>          </p>
>> +
>>  	<p>
>> -	  You must specify the gcc option <tt>-D_REENTRANT</tt>
>> -	  when building a library (either static or shared) to make
>> -	  the library compatible with LinuxThreads.
>> +	  Libraries should be built with threading support and to be
>> +	  thread-safe if the library supports this.
>>  	</p>
>>  
>>          <p>

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Mon, 05 Jul 2010 08:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon Josefsson <simon@josefsson.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 05 Jul 2010 08:24:03 GMT) Full text and rfc822 format available.

Message #79 received at 475101@bugs.debian.org (full text, mbox):

From: Simon Josefsson <simon@josefsson.org>
To: Russ Allbery <rra@debian.org>
Cc: 475101@bugs.debian.org, Kurt Roeckx <kurt@roeckx.be>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Mon, 05 Jul 2010 10:20:43 +0200
Russ Allbery <rra@debian.org> writes:

>> 	<p>
>> 	  Libraries should be built with threading support and to be
>> 	  thread-safe if the library supports this.
>> 	</p>
>
> Yes, that's what I'm proposing -- at a guess, you may have misread the
> diff?
>
>>> diff --git a/policy.sgml b/policy.sgml
>>> index bad28af..1ffe148 100644
>>> --- a/policy.sgml
>>> +++ b/policy.sgml
>>> @@ -7225,10 +7225,10 @@ INSTALL = install -s # (or use strip on the files in debian/tmp)
>>>            for C files) will need to be compiled twice, for the normal
>>>            case. 
>>>          </p>
>>> +
>>>  	<p>
>>> -	  You must specify the gcc option <tt>-D_REENTRANT</tt>
>>> -	  when building a library (either static or shared) to make
>>> -	  the library compatible with LinuxThreads.
>>> +	  Libraries should be built with threading support and to be
>>> +	  thread-safe if the library supports this.
>>>  	</p>

Sorry, for some reason I must have completely missed the '-' in your
patch.  Then +1 from me.

Hm.  There is a small risk that the above will be interpreted to mean
that e.g. pthreads should be enabled if supported by the library, but
that is not always the best solution -- consider if a library supports
native linking to pthreads, nptl, GNU Pth, or no thread library but
require the application to provide mutex callbacks.  (We are actually
considering something like that for GnuTLS now, so it is not entirely
hypothetical.)  I would argue that the best for debian would be to build
the library in the last configuration.  Or can we declare that Debian
only supports one thread package?  The problem, of course, is that some
applications will be using pthreads and some will use nptl, and linking
libraries that are hard-coded to use pthreads (or nptl) will not work
well.

However, I suspect the wording above is sufficient, and that it is not a
good idea to go into more details in a policy document.  I just wanted
to float this concern, to see if it sparks thoughts in anyone else.

/Simon




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Mon, 05 Jul 2010 17:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kurt Roeckx <kurt@roeckx.be>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Mon, 05 Jul 2010 17:15:03 GMT) Full text and rfc822 format available.

Message #84 received at 475101@bugs.debian.org (full text, mbox):

From: Kurt Roeckx <kurt@roeckx.be>
To: Simon Josefsson <simon@josefsson.org>
Cc: Russ Allbery <rra@debian.org>, 475101@bugs.debian.org, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Mon, 5 Jul 2010 19:12:51 +0200
On Mon, Jul 05, 2010 at 10:20:43AM +0200, Simon Josefsson wrote:
> 
> Hm.  There is a small risk that the above will be interpreted to mean
> that e.g. pthreads should be enabled if supported by the library, but
> that is not always the best solution -- consider if a library supports
> native linking to pthreads, nptl, GNU Pth, or no thread library but
> require the application to provide mutex callbacks.  (We are actually
> considering something like that for GnuTLS now, so it is not entirely
> hypothetical.)  I would argue that the best for debian would be to build
> the library in the last configuration.  Or can we declare that Debian
> only supports one thread package?  The problem, of course, is that some
> applications will be using pthreads and some will use nptl, and linking
> libraries that are hard-coded to use pthreads (or nptl) will not work
> well.

The current situation with openssl is that they provide callback
mechanisms for that.  And it really doesn't seem to be working
very well for them.  The problem is that both libraries using
openssl and applications using it should be setting them, and it
might end up linking to openssl directly and indirectly and ends
in a mess.  It's one of the topics that regurarly come back.

Linux threads and NPTL both provide the POSIX API to do threads
and both use "-lpthread", it's just the internal implementation
of the library that is different. libpth on the other hand
seems to be having it's own API, so you also link to an other
library.

Anyway, there is a difference between a library being thread safe,
which is what we want, and a library creating it's own threads.
To be thread safe you can use various ways, but it includes
synchronisation objects, and how you do that isn't really
important.  And some people will argue that the application making
use of the library will know what the best type is, and so will
prefer a callback mechanism.  It also makes sure there is no
overhead in case no threads are being used.  But on the other
hand it's very handy that a library sets this up itself without
the applications needing to care.


Kurt





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Thu, 15 Jul 2010 07:39:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Giacomo A. Catenazzi" <cate@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Thu, 15 Jul 2010 07:39:06 GMT) Full text and rfc822 format available.

Message #89 received at 475101@bugs.debian.org (full text, mbox):

From: "Giacomo A. Catenazzi" <cate@debian.org>
To: 475101@bugs.debian.org
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Thu, 15 Jul 2010 09:31:09 +0200
On 04.07.2010 10:42, Kurt Roeckx wrote:
> On Sat, Jul 03, 2010 at 12:26:40PM -0700, Russ Allbery wrote:
>> --- a/policy.sgml
>> +++ b/policy.sgml
>> @@ -7225,10 +7225,10 @@ INSTALL = install -s # (or use strip on the files in debian/tmp)
>>             for C files) will need to be compiled twice, for the normal
>>             case.
>>           </p>
>> +
>>   	<p>
>> -	  You must specify the gcc option<tt>-D_REENTRANT</tt>
>> -	  when building a library (either static or shared) to make
>> -	  the library compatible with LinuxThreads.
>> +	  Libraries should be built with threading support and to be
>> +	  thread-safe if the library supports this.
>>   	</p>
>>
>>           <p>
>
> Seconded.

Seconded.

ciao
	cate




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Policy List <debian-policy@lists.debian.org>:
Bug#475101; Package debian-policy. (Thu, 15 Jul 2010 18:03:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Russ Allbery <rra@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Policy List <debian-policy@lists.debian.org>. (Thu, 15 Jul 2010 18:03:08 GMT) Full text and rfc822 format available.

Message #94 received at 475101@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 475101@bugs.debian.org
Cc: Kurt Roeckx <kurt@roeckx.be>, Simon Josefsson <simon@josefsson.org>, Joey Hess <joeyh@debian.org>
Subject: Re: Bug#475101: obsolete linuxthreads requirement
Date: Thu, 15 Jul 2010 10:59:38 -0700
Russ Allbery <rra@debian.org> writes:

> Here's an attempt at that.  I'm not sure if this says everything that
> needs to be said, but I'm not sure what else to say.

> I considered saying, as Kurt does above, that two libraries could be
> provided, one with thread support and one without, but this poses some
> serious problems because both libraries could be loaded into the same
> process space and then conflict.  Doing this properly requires symbol
> versioning or some other similar mechanism, and at that point I think
> we're getting into something that's too difficult and specific to describe
> in Policy.  I think I'd rather just let the "should" rather than "must"
> provide wiggle-room for that.

> Objections or seconds?

This change has now been merged for the next release.

-- 
Russ Allbery (rra@debian.org)               <http://www.eyrie.org/~eagle/>




Added tag(s) pending; removed tag(s) patch. Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Thu, 15 Jul 2010 18:03:13 GMT) Full text and rfc822 format available.

Changed Bug title to 'Remove obsolete -D_REENTRANT requirement' from 'obsolete linuxthreads requirement' Request was from Russ Allbery <rra@debian.org> to control@bugs.debian.org. (Fri, 16 Jul 2010 17:33:06 GMT) Full text and rfc822 format available.

Reply sent to Russ Allbery <rra@debian.org>:
You have taken responsibility. (Mon, 26 Jul 2010 05:06:21 GMT) Full text and rfc822 format available.

Notification sent to Joey Hess <joeyh@debian.org>:
Bug acknowledged by developer. (Mon, 26 Jul 2010 05:06:22 GMT) Full text and rfc822 format available.

Message #103 received at 475101-close@bugs.debian.org (full text, mbox):

From: Russ Allbery <rra@debian.org>
To: 475101-close@bugs.debian.org
Subject: Bug#475101: fixed in debian-policy 3.9.1.0
Date: Mon, 26 Jul 2010 05:02:07 +0000
Source: debian-policy
Source-Version: 3.9.1.0

We believe that the bug you reported is fixed in the latest version of
debian-policy, which is due to be installed in the Debian FTP archive:

debian-policy_3.9.1.0.dsc
  to main/d/debian-policy/debian-policy_3.9.1.0.dsc
debian-policy_3.9.1.0.tar.gz
  to main/d/debian-policy/debian-policy_3.9.1.0.tar.gz
debian-policy_3.9.1.0_all.deb
  to main/d/debian-policy/debian-policy_3.9.1.0_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 475101@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Russ Allbery <rra@debian.org> (supplier of updated debian-policy package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 25 Jul 2010 19:38:21 -0700
Source: debian-policy
Binary: debian-policy
Architecture: source all
Version: 3.9.1.0
Distribution: unstable
Urgency: low
Maintainer: Debian Policy List <debian-policy@lists.debian.org>
Changed-By: Russ Allbery <rra@debian.org>
Description: 
 debian-policy - Debian Policy Manual and related documents
Closes: 104373 175202 184064 186102 218897 232448 400322 402721 436105 445203 475101 477240 509932 509933 555977 561413 588750 589362 589605 589609
Changes: 
 debian-policy (3.9.1.0) unstable; urgency=low
 .
   * Policy: Include GPL version 1 in common-licenses
     Wording: Russ Allbery <rra@debian.org>
     Seconded: gregor herrmann <gregoa@debian.org>
     Seconded: Damyan Ivanov <dmn@debian.org>
     Seconded: Giacomo A. Catenazzi <cate@debian.org>
     Closes: #436105
   * Policy: Libtool *.la files should generally not be installed
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Cyril Brulebois <kibi@debian.org>
     Closes: #561413
   * Policy: Require dpkg-divert --package when adding/removing diversions
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Seconded: Raphael Geissert <geissert@debian.org>
     Closes: #218897
   * Policy: Remove encouragement to create shlibs.local
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Jakub Wilk <jwilk@debian.org>
     Seconded: Cyril Brulebois <kibi@debian.org>
   * Policy: Document alternate SONAME format with version before .so
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Closes: #509932
   * Policy: Architecture wildcards also allowed in binary relationships
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Closes: #400322
   * Policy: Say Conflicts should not be used unless necessary
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Jakub Wilk <jwilk@debian.org>
     Closes: #402721
   * Policy: Remove obsolete _REENTRANT, require thread-safe libraries
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Kurt Roeckx <kurt@roeckx.be>
     Seconded: Giacomo A. Catenazzi <cate@debian.org>
     Closes: #475101
   * Policy: Allow subdirectories of /usr/lib/cgi-bin to be used
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Andrew McMillan <andrew@morphoss.com>
     Seconded: Charles Plessy <plessy@debian.org>
     Closes: #104373
   * Policy: More specific requirements around date-based versions
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Seconded: Cyril Brulebois <kibi@debian.org>
     Seconded: Steve Langasek <vorlon@debian.org>
     Closes: #186102
   * Policy: Require slave alternatives for manual pages
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Jakub Wilk <jwilk@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Closes: #184064
   * Policy: More explicit requirements around library SONAMEs
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Raphaël Hertzog <hertzog@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu27@gmail.com>
     Closes: #509933
   * Policy: Only dpkg-gencontrol supports variable substitutions
     Wording: Charles Plessy <plessy@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Closes: #589609
   * Policy: Ada Library Information files must be read-only
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Ludovic Brenta <ludovic@ludovic-brenta.org>
     Closes: #232448
   * Policy: Recommend /etc/logrotate.d/package for logrotate rules
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Guillem Jover <guillem@debian.org>
     Seconded: Thijs Kinkhorst <thijs@debian.org>
     Closes: #445203
   * Policy: Allow /bin/sh scripts to rely on XSI for kill and trap
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Giacomo A. Catenazzi <cate@debian.org>
     Seconded: Raphael Geissert <geissert@debian.org>
     Closes: #477240
   * Policy: Ownership and permissions for control information files
     Wording: Russ Allbery <rra@debian.org>
     Seconded: Emilio Pozuelo Monfort <pochu@debian.org>
     Seconded: Julien Cristau <jcristau@debian.org>
     Closes: #555977
   * Set the version of the Perl Policy to match the version of the Policy
     package.
   * Explain the Perl module package naming policy more explicitly and
     provide some examples.  (Closes: #175202)
   * Revise the footnote discussing shlibs creation to not talk about the
     switch to objdump as if it were a new innovation and to explicitly
     mention the NEEDED attribute as the source of dependency information.
   * Introduce "control information file" to refer to the contents of the
     Debian package control.tar.gz, following the dpkg documentation.  Use
     that terminology consistently, and change possibly confusing
     references to fields in control files to use "control field"
     uniformly.
   * Document that the first line of the changelog entry is conventionally
     an explanation for the upload if the uploader is not the regular
     maintainer.  Patch from Charles Plessy.  (Closes: #589605)
   * Fix typo in upgrading-checklist.  (Closes: #588750)
   * Fix formatting error in footnote to 7.7.  (Closes: #589362)
   * Remove ancient Conflicts and Replaces.
Checksums-Sha1: 
 1dc24a34db96f2c812fc560281cd3460256f72e7 1204 debian-policy_3.9.1.0.dsc
 af1c2192f6fc3c241618b48688f4d714aa630da2 690539 debian-policy_3.9.1.0.tar.gz
 1a94fda2ee6ad584efc2dab420178b993b028545 1852358 debian-policy_3.9.1.0_all.deb
Checksums-Sha256: 
 e81bc2f72659dd75a94ee4b6ba3dfe26ddf09811ece2e00cf2ebf9372ca68b98 1204 debian-policy_3.9.1.0.dsc
 7322f07e9bcd80dc3379f2545e7be7b93a2dc48b30b490b6277082024d98e847 690539 debian-policy_3.9.1.0.tar.gz
 facfbcbc037f7fb768cb9a42f72da3bff750922b8828fce633cc400012a71744 1852358 debian-policy_3.9.1.0_all.deb
Files: 
 10aae2bd3a3c14fb6853f26b9b97de55 1204 doc optional debian-policy_3.9.1.0.dsc
 3a8ac906da51c3574c6e92aa6c12af8e 690539 doc optional debian-policy_3.9.1.0.tar.gz
 182e7d0f26b29101150014c9bd2fa8eb 1852358 doc optional debian-policy_3.9.1.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkxNE9EACgkQ+YXjQAr8dHZzsACg2tBvXhJKJNRtTDg2XwJdG1es
RzcAoI2YCA0+mnxQa4QapbxlH44szEML
=8Iyg
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 02 Sep 2010 07:29:54 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 18:59:14 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.